package com.training.catalog.controller;

import java.util.List;
import java.util.Optional;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.training.catalog.model.Product;
import com.training.catalog.service.CatalogService;

@RestController
@RequestMapping("/catalog")
public class CatalogController {

	@Autowired
	private CatalogService catalogService;

	@GetMapping
	public ResponseEntity<List<Product>> getBagProducts() {
		return new ResponseEntity<List<Product>>(catalogService.getProducts(), HttpStatus.OK);
	}


	@GetMapping("/{name}")
	public ResponseEntity<Optional<Product>> getProductWith(@PathVariable("name") String name) {

		Optional<Product> productName =catalogService.getProduct(name);
		if(productName.isPresent()) {
			return new ResponseEntity<Optional<Product> >(productName, HttpStatus.OK);
		}
		return new ResponseEntity<Optional<Product> >(HttpStatus.NOT_FOUND);
	}

}
