package com.training.catalog.service;

import java.util.List;
import java.util.Optional;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.training.catalog.model.Product;
import com.training.catalog.respository.CatalogRepository;

@Service
public class CatalogServiceImpl implements CatalogService {

	@Autowired
	private CatalogRepository catalogRepository;

	@Override
	public List<Product> getProducts() {
		List<Product> listOfProducts = catalogRepository.findAll();
		return listOfProducts;
	}

	@Override
	public Optional<Product> getProduct(String name) {

		if (catalogRepository.existsById(name)) {
			Optional<Product> findById = catalogRepository.findById(name);
			if (findById.isPresent()) {
				return findById;
			}
		}
		return Optional.empty();
	}

}
